#include <bits/stdc++.h>
using namespace std;
int n,q,a,b;
int niz[200007];
int main(){
  cin>>n;
  for(int i=1;i<=n-1;i++){
      cin>>a>>b;
  }
  int maxi=-1e9;
  int br;
  for(int i=1;i<=n;i++){
      cin>>niz[i];
  }
  for(int i=1;i<=n;i++){
      if(niz[i]>maxi){
         maxi=niz[i];
         br=i;
      }
  }
  cout<<br<<endl;
  cin>>q;
  return 0;
}